﻿Imports System.Windows.Forms.DataVisualization.Charting

Public Class Form_main
    Dim file As System.IO.StreamWriter
    Dim file_log As System.IO.StreamWriter

    Dim server_connected As Boolean = False
    Dim buf_read(100) As Char
    Dim buf_read_index As Integer = 0
    Dim rec As Boolean = False
    Dim fwrite As Boolean = False
    Dim rec_start As Boolean = False
    Dim record_no_graph As Long

    Private Structure HW_STAT
        Shared empty As Boolean = True
        Shared THardWare_version As String
        Shared TFirmWare_version As String
        Shared Register_HighPrecision_CH1 As Integer
        Shared Register_HighPrecision_CH2 As Integer
        Shared Register_LowPrecision_CH1 As Integer
        Shared Register_LowPrecision_CH2 As Integer
        Shared ZeroCross_curcuit As Boolean
        Shared RFirmWare_version As String

        Shared MAX_AMP_CH1 As Double
        Shared MAX_AMP_CH2 As Double
    End Structure

    Delegate Sub RecieveDataDisplayDelegate( _
         ByVal command As String, _
         ByVal ch1_range As String, _
         ByVal ch2_range As String, _
         ByVal watt_ch1 As Integer, _
         ByVal watt_ch2 As Integer, _
         ByVal va_ch1 As Integer, _
         ByVal va_ch2 As Integer, _
         ByVal seq_no As Long)

    Private Sub data_display( _
         ByVal command As String, _
         ByVal ch1_range As String, _
         ByVal ch2_range As String, _
         ByVal watt_ch1 As Integer, _
         ByVal watt_ch2 As Integer, _
         ByVal va_ch1 As Integer, _
         ByVal va_ch2 As Integer, _
         ByVal seq_no As Long)
        Dim pf1 As String
        Dim pf2 As String
        Dim watt1 As String
        Dim watt2 As String
        Dim va1 As String = ""
        Dim va2 As String = ""
        Dim format_ch1 As String
        Dim format_ch2 As String

        If ch1_range = "H" Then
            format_ch1 = "0.0"
        Else
            format_ch1 = "0"
        End If
        If ch2_range = "H" Then
            format_ch2 = "0.0"
        Else
            format_ch2 = "0"
        End If
        va1 = (va_ch1 / 10).ToString(format_ch1)
        va2 = (va_ch2 / 10).ToString(format_ch2)

        If HW_STAT.ZeroCross_curcuit Then
            watt1 = (watt_ch1 / 10).ToString(format_ch1)
            watt2 = (watt_ch2 / 10).ToString(format_ch2)
            If va_ch1 = 0 Then
                pf1 = "0"
            Else
                pf1 = CInt((watt_ch1 * 100 / va_ch1)).ToString
            End If
            If va_ch2 = 0 Then
                pf2 = "0"
            Else
                pf2 = CInt((watt_ch2 * 100 / va_ch2)).ToString
            End If
            If (record_no_graph < 21600) Or (Not fwrite) Then
                Chart1.Series(0).Points.AddXY(record_no_graph, CDbl(watt1))
                Chart1.Series(1).Points.AddXY(record_no_graph, CDbl(va1))
                Chart1.Series(2).Points.AddXY(record_no_graph, CDbl(pf1))
                Chart1.Series(3).Points.AddXY(record_no_graph, CDbl(watt2))
                Chart1.Series(4).Points.AddXY(record_no_graph, CDbl(va2))
                Chart1.Series(5).Points.AddXY(record_no_graph, CDbl(pf2))
            End If
        Else
            watt1 = "-"
            watt2 = "-"
            pf1 = "-"
            pf2 = "-"
            If (record_no_graph < 21600) Or (Not fwrite) Then
                Chart1.Series(1).Points.AddXY(record_no_graph, CDbl(va1))
                Chart1.Series(4).Points.AddXY(record_no_graph, CDbl(va2))
            End If
        End If
        display_text(watt1, watt2, va1, va2, pf1, pf2)
        Label_data.Text = command

        If fwrite Then
            file.Write("DATA,")
            file.Write(ch1_range) : file.Write(",")
            file.Write(ch2_range) : file.Write(",")
            file.Write(watt1) : file.Write(",")
            file.Write(va1) : file.Write(",")
            file.Write(pf1) : file.Write(",")
            file.Write(watt2) : file.Write(",")
            file.Write(va2) : file.Write(",")
            file.Write(pf2) : file.Write(",")
            file.WriteLine(seq_no)
        End If
        Label_seq_no.Text = "記録番号：" & record_no_graph
    End Sub

    Private Sub display_text(watt1 As String, watt2 As String, va1 As String, va2 As String, pf1 As String, pf2 As String)
        Label_ch1_watt.Text = "電力：" & watt1 & " [W]"
        Label_ch2_watt.Text = "電力：" & watt2 & " [W]"
        Label_ch1_va.Text = "皮相：" & va1 & " [VA]"
        Label_ch2_va.Text = "皮相：" & va2 & " [VA]"
        Label_ch1_pf.Text = "力率：" & pf1.ToString & " [%]"
        Label_ch2_pf.Text = "力率：" & pf2.ToString & " [%]"
    End Sub

    Private Sub SystemEvents_PowerModeChanged(ByVal sender As Object, ByVal PowerModeChangedEvent As Microsoft.Win32.PowerModeChangedEventArgs)
        If PowerModeChangedEvent.Mode = Microsoft.Win32.PowerModes.Resume Then
            System.Threading.Thread.Sleep(5000) ' 速く起動されるとarduinoの準備が出来ていない
            wattmeter_activate()
        Else
            wattmeter_deactivate()
        End If
    End Sub

    Dim seq_no_recieve As Long
    Dim seq_no_current As Long

    Private Sub SerialPort1_DataReceived(sender As System.Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim buf_write(20) As Byte
        Dim rbytes As Integer

        Dim data_displayMethod As New RecieveDataDisplayDelegate(AddressOf data_display)
        Dim set_max_ampMethod As New set_max_ampDelegate(AddressOf set_max_amp)
        Dim set_versionMethod As New set_versionDelegate(AddressOf set_version)
        Dim set_zero_crossMethod As New set_zero_crossDelegate(AddressOf set_zero_cross)

        Dim ch1_range As String
        Dim ch2_range As String
        Dim ch1_watt As Integer
        Dim ch2_watt As Integer
        Dim ch1_va As Integer
        Dim ch2_va As Integer
        Dim strarray As String()

        Try
            rbytes = SerialPort1.BytesToRead
            While rbytes > 0 And SerialPort1.IsOpen
                'MsgBox(SerialPort1.PortName)
                buf_read(buf_read_index) = Chr(SerialPort1.ReadByte)
                If buf_read(buf_read_index) = "#" Then
                    Dim recive_string As New String(buf_read, 0, buf_read_index)
                    file_log.WriteLine(recive_string)
                    file_log.Flush()
                    If buf_read(0) = "s" Then ' PC受信開始のACK
                        server_connected = True
                        buf_read_index = 0
                        Exit While
                    End If
                    If server_connected Then
                        Select Case buf_read(0)
                            Case "A"  ' 電力受信
                                Try
                                    strarray = recive_string.Split(",")
                                    seq_no_recieve = Long.Parse(strarray(1))

                                    ch1_range = strarray(2)
                                    ch2_range = strarray(3)

                                    test_range(ch1_range, ch2_range)
                                    ch1_watt = Integer.Parse(strarray(4))
                                    ch1_va = Integer.Parse(strarray(5))
                                    ch2_watt = Integer.Parse(strarray(6))
                                    ch2_va = Integer.Parse(strarray(7))
                                    seq_no_current = Long.Parse(strarray(8))

                                    If rec_start Then
                                        rec_start = False
                                        record_no_graph = 0
                                    End If

                                    If (Not rec) And (seq_no_recieve < seq_no_current - 10) Then
                                        file_log.WriteLine("@ rewind")
                                        SerialPort1.Write("d" & seq_no_current & "#")
                                    End If
                                    If Not CheckBox_pause.Checked Then
                                        Me.Invoke(data_displayMethod, _
                                                  recive_string, _
                                                  ch1_range, _
                                                  ch2_range, _
                                                  ch1_watt, _
                                                  ch2_watt, _
                                                  ch1_va, _
                                                  ch2_va, _
                                                  seq_no_recieve)
                                        record_no_graph = record_no_graph + 1
                                    End If
                                Catch ex As Exception
                                    file_log.WriteLine("@ ERROR >>" & recive_string)
                                End Try
                            Case "Q"  ' WatchDog
                                SerialPort1.Write("q#")
                            Case "w"
                                server_connected = False
                                'System.Threading.Thread.Sleep(1000)
                                SerialPort1.Close()
                                Exit Sub
                            Case "v"
                                strarray = recive_string.Split(",")
                                HW_STAT.THardWare_version = strarray(1)
                                HW_STAT.TFirmWare_version = strarray(2)
                                HW_STAT.Register_HighPrecision_CH1 = strarray(3)
                                HW_STAT.Register_HighPrecision_CH2 = strarray(5)
                                HW_STAT.Register_LowPrecision_CH1 = strarray(4)
                                HW_STAT.Register_LowPrecision_CH2 = strarray(6)
                                If strarray(7) = "Z" Then
                                    HW_STAT.ZeroCross_curcuit = True
                                Else
                                    HW_STAT.ZeroCross_curcuit = False
                                End If
                                HW_STAT.RFirmWare_version = strarray(8)
                                HW_STAT.empty = False
                                Me.Invoke(set_max_ampMethod)
                                Me.Invoke(set_versionMethod)
                                Me.Invoke(set_zero_crossMethod, HW_STAT.ZeroCross_curcuit)
                            Case Else
                                file_log.WriteLine("@" & recive_string)
                                file_log.Flush()
                        End Select
                    End If
                    buf_read_index = 0
                Else
                    buf_read_index = buf_read_index + 1
                    rbytes = rbytes - 1
                End If
            End While
        Catch ex As System.IO.IOException
            MsgBox("Arduinoと通信エラー", vbExclamation, "ERROR")
        End Try
    End Sub

    Delegate Sub set_max_ampDelegate()
    Private Sub set_max_amp()
        Dim amp_ch1 As Double
        Dim amp_ch2 As Double

        If HW_STAT.empty = True Then
            Exit Sub
        End If
        If RadioButton_hr_ch1.Checked Then
            amp_ch1 = 2.3 * 3000 / HW_STAT.Register_HighPrecision_CH1
        Else
            amp_ch1 = 2.3 * 3000 / HW_STAT.Register_LowPrecision_CH1
        End If
        If RadioButton_hr_ch2.Checked Then
            amp_ch2 = 2.3 * 3000 / HW_STAT.Register_HighPrecision_CH2
        Else
            amp_ch2 = 2.3 * 3000 / HW_STAT.Register_LowPrecision_CH2
        End If
        Label_max_amp_ch1.Text = "最大電流:" & amp_ch1.ToString("0.0") & "[A]"
        Label_max_amp_ch2.Text = "最大電流:" & amp_ch2.ToString("0.0") & "[A]"
    End Sub

    Delegate Sub set_versionDelegate()
    Private Sub set_version()
        Label_transmitter_HW.Text = "Transmitter H/W Ver:" & HW_STAT.THardWare_version
        Label_transmitter_FW.Text = "Transmitter F/W Ver:" & HW_STAT.TFirmWare_version
        If HW_STAT.THardWare_version = "3" Then
            Label_receiver_FW.Text = "Receiver    F/W Ver:" & HW_STAT.RFirmWare_version
        Else
            Label_receiver_FW.Text = ""
        End If
    End Sub

    Delegate Sub set_zero_crossDelegate(ByVal zc As Boolean)
    Private Sub set_zero_cross(ByVal zc As Boolean)
        If zc Then
            CheckBox_disp_watt_ch1.Enabled = True
            CheckBox_disp_pf_ch1.Enabled = True
            CheckBox_disp_watt_ch2.Enabled = True
            CheckBox_disp_pf_ch2.Enabled = True
        Else
            CheckBox_disp_va_ch1.Checked = True
            CheckBox_disp_va_ch2.Checked = True
            CheckBox_disp_watt_ch1.Enabled = False
            CheckBox_disp_watt_ch1.Checked = False
            CheckBox_disp_pf_ch1.Enabled = False
            CheckBox_disp_pf_ch1.Checked = False
            CheckBox_disp_watt_ch2.Enabled = False
            CheckBox_disp_watt_ch2.Checked = False
            CheckBox_disp_pf_ch2.Enabled = False
            CheckBox_disp_pf_ch2.Checked = False
        End If
    End Sub

    Private Function wattmeter_activate() As Boolean
        Dim comport_find As Boolean = False

        For retry_couynter1 = 0 To 4 ' 数回リトライする
            If My.Computer.Ports.SerialPortNames.Count = 0 Then
                System.Threading.Thread.Sleep(1000)
                Application.DoEvents()
                Continue For
            Else
                Exit For
            End If
        Next

        For Each sp_name As String In My.Computer.Ports.SerialPortNames
            SerialPort1.PortName = sp_name
            Try
                SerialPort1.Open()
            Catch ex As UnauthorizedAccessException
                MsgBox("open error")
                Continue For
            End Try
            buf_read_index = 0
            SerialPort1.DiscardInBuffer()
            SerialPort1.Write("S#S#")  ' 念のため２回スタートコマンドを送っている。２回送っても副作用は無い
            System.Threading.Thread.Sleep(1000)
            Application.DoEvents()
            If server_connected Then
                comport_find = True
                Label_comport.BackColor = Color.LightGreen 'ボタンを緑にする
                Label_comport.Text = sp_name
                For retry_couynter3 = 0 To 6 ' 数回リトライする
                    SerialPort1.Write("V#V#")
                    System.Threading.Thread.Sleep(1000)
                    Application.DoEvents()
                    If HW_STAT.empty = False Then
                        SplashScreen1.Close()
                        Return True
                    End If
                Next
                Label_comport.BackColor = SystemColors.Control
            End If
            server_connected = False
            SerialPort1.Close()
        Next

        SplashScreen1.Close()
        If comport_find Then
            MsgBox("受信機と接続できたが電力計と無線通信できない" & vbCr & "計測は出来ません", vbExclamation, "ERROR")
        Else
            MsgBox("受信機が見つからない" & vbCr & "計測は出来ません", vbExclamation, "ERROR")
        End If

        Return False
    End Function

    Private Sub wattmeter_deactivate()
        If SerialPort1.IsOpen Then
            SerialPort1.Write("W#W#")
            System.Threading.Thread.Sleep(1000)
            Application.DoEvents()
            SerialPort1.Close()
        End If
    End Sub

    Private Sub Form_main_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        wattmeter_deactivate()
        If rec Then
            file.Flush()
            file.Close()
        End If
        file_log.Flush()
        file_log.Close()
    End Sub

    Private Sub Form_main_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim data_path = System.AppDomain.CurrentDomain.BaseDirectory & "data\"
        If Not System.IO.Directory.Exists(data_path) Then
            System.IO.Directory.CreateDirectory(data_path)
        End If
        file_log = My.Computer.FileSystem.OpenTextFileWriter(data_path & "log.txt", False)

        HW_STAT.empty = True
        If wattmeter_activate() Then
            Button_rec.Enabled = True
            RadioButton_hr_ch1.Enabled = True
            RadioButton_lr_ch1.Enabled = True
            RadioButton_hr_ch2.Enabled = True
            RadioButton_lr_ch2.Enabled = True
        Else
            Button_rec.Enabled = False
            RadioButton_hr_ch1.Enabled = False
            RadioButton_lr_ch1.Enabled = False
            RadioButton_hr_ch2.Enabled = False
            RadioButton_lr_ch2.Enabled = False
        End If
        buf_read_index = 0
        record_no_graph = 0
        For series_no = 0 To 5
            Chart1.Series(series_no).Points.Clear()
        Next
        AddHandler Microsoft.Win32.SystemEvents.PowerModeChanged, AddressOf SystemEvents_PowerModeChanged
    End Sub

    Private Sub Button_rec_Click(sender As System.Object, e As System.EventArgs) Handles Button_rec.Click
        If rec Then
            file.Close()
            Button_rec.BackColor = Color.Gainsboro
            Button_rec.ForeColor = Color.Black
            rec = False
            fwrite = False
            rec_start = False
            CheckBox_pause.Checked = True
            CheckBox_pause.Enabled = True
        Else
            Dim fname As String = System.AppDomain.CurrentDomain.BaseDirectory _
                                  & "data\raw" & System.DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".csv"
            file = My.Computer.FileSystem.OpenTextFileWriter(fname, False, System.Text.Encoding.ASCII)
            file.WriteLine("(DATE),DateTime," & System.DateTime.Now)
            file.WriteLine("(THWV),Transmitter HardWare Version," & HW_STAT.THardWare_version)
            file.WriteLine("(TFWV),Transmitter FirmWare Version," & HW_STAT.TFirmWare_version)
            file.WriteLine("(RHP1),Register High Precision CH1," & HW_STAT.Register_HighPrecision_CH1)
            file.WriteLine("(RLP1),Register Low  Precision CH1," & HW_STAT.Register_LowPrecision_CH1)
            file.WriteLine("(RHP2),Register High Precision CH2," & HW_STAT.Register_HighPrecision_CH2)
            file.WriteLine("(RLP2),Register Low  Precision CH2," & HW_STAT.Register_LowPrecision_CH2)
            If HW_STAT.ZeroCross_curcuit Then
                file.WriteLine("(ZCON),ZeroCross curcuit,ON")
            Else
                file.WriteLine("(ZCON),ZeroCross curcuit,OFF")
            End If
            file.WriteLine("(RFWV),Receiver    FirmWare Version," & HW_STAT.RFirmWare_version)
            file.WriteLine("START,-----------------------------------------")
            Button_rec.BackColor = Color.LightPink
            Button_rec.ForeColor = Color.Red
            rec = True
            'init_rec = True
            fwrite = True
            rec_start = True
            For series_no = 0 To 5
                Chart1.Series(series_no).Points.Clear()
            Next
            CheckBox_pause.Checked = False
            CheckBox_pause.Enabled = False
            Label_time.Text = "開始時刻:" & System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:dd")
        End If
    End Sub

    Private Sub test_range(ch1 As String, ch2 As String)
        Dim range_ch1 As String
        Dim range_ch2 As String

        If RadioButton_hr_ch1.Checked Then
            range_ch1 = "H"
        Else
            range_ch1 = "L"
        End If
        If RadioButton_hr_ch2.Checked Then
            range_ch2 = "H"
        Else
            range_ch2 = "L"
        End If

        If (ch1 <> range_ch1) Or (ch2 <> range_ch2) Then
            SerialPort1.Write("R" & range_ch1 & range_ch2 & "#")
        End If
    End Sub

    Private Sub CheckBox_disp_watt_ch1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_disp_watt_ch1.CheckedChanged
        If CheckBox_disp_watt_ch1.Checked Then
            Chart1.Series(0).Enabled = True
        Else
            Chart1.Series(0).Enabled = False
        End If
    End Sub

    Private Sub CheckBox_disp_va_ch1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_disp_va_ch1.CheckedChanged
        If CheckBox_disp_va_ch1.Checked Then
            Chart1.Series(1).Enabled = True
        Else
            Chart1.Series(1).Enabled = False
        End If
    End Sub

    Private Sub CheckBox_disp_pf_ch1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_disp_pf_ch1.CheckedChanged
        If CheckBox_disp_pf_ch1.Checked Then
            Chart1.Series(2).Enabled = True
        Else
            Chart1.Series(2).Enabled = False
        End If
    End Sub

    Private Sub CheckBox_disp_watt_ch2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_disp_watt_ch2.CheckedChanged
        If CheckBox_disp_watt_ch2.Checked Then
            Chart1.Series(3).Enabled = True
        Else
            Chart1.Series(3).Enabled = False
        End If
    End Sub

    Private Sub CheckBox_disp_va_ch2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_disp_va_ch2.CheckedChanged
        If CheckBox_disp_va_ch2.Checked Then
            Chart1.Series(4).Enabled = True
        Else
            Chart1.Series(4).Enabled = False
        End If
    End Sub

    Private Sub CheckBox_disp_pf_ch2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_disp_pf_ch2.CheckedChanged
        If CheckBox_disp_pf_ch2.Checked Then
            Chart1.Series(5).Enabled = True
        Else
            Chart1.Series(5).Enabled = False
        End If
    End Sub

    Private Sub RadioButton_hr_ch1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_hr_ch1.CheckedChanged
        set_max_amp()
    End Sub

    Private Sub RadioButton_hr_ch2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_hr_ch2.CheckedChanged
        set_max_amp()
    End Sub

    Private Sub Fopen_Click(sender As System.Object, e As System.EventArgs) Handles Fopen.Click
        Dim dialog As New OpenFileDialog()
        Dim buf() As String
        Dim total_watt_ch1 As Double = 0
        Dim total_watt_ch2 As Double = 0
        Dim total_va_ch1 As Double = 0
        Dim total_va_ch2 As Double = 0

        CheckBox_pause.Checked = True
        dialog.InitialDirectory = System.AppDomain.CurrentDomain.BaseDirectory & "\data"
        dialog.Filter = "WattMeterFile|*.csv"
        dialog.Title = "ファイルを選択"
        If dialog.ShowDialog() = DialogResult.OK Then
            For series_no = 0 To 5
                Chart1.Series(series_no).Points.Clear()
            Next
            'rec = True
            Dim input_file As FileIO.TextFieldParser
            input_file = My.Computer.FileSystem.OpenTextFieldParser(dialog.FileName, ",")
            record_no_graph = 0
            While Not input_file.EndOfData
                buf = input_file.ReadFields
                Select Case buf(0)
                    Case "(DATE)" : Label_time.Text = "開始時刻：" & Date.Parse(buf(2))
                    Case "(THWV)" : HW_STAT.THardWare_version = buf(2)
                    Case "(TFWV)" : HW_STAT.TFirmWare_version = buf(2)
                    Case "(RHP1)" : HW_STAT.Register_HighPrecision_CH1 = buf(2)
                    Case "(RLP1)" : HW_STAT.Register_LowPrecision_CH1 = buf(2)
                    Case "(RHP2)" : HW_STAT.Register_HighPrecision_CH2 = buf(2)
                    Case "(RLP2)" : HW_STAT.Register_LowPrecision_CH2 = buf(2)
                    Case "(ZCON)"
                        If buf(2) = "ON" Then
                            HW_STAT.ZeroCross_curcuit = True
                        Else
                            HW_STAT.ZeroCross_curcuit = False
                        End If
                    Case "(RFWV)" : HW_STAT.RFirmWare_version = buf(2)
                    Case "START"
                        set_max_amp()
                        set_version()
                        set_zero_cross(HW_STAT.ZeroCross_curcuit)
                    Case "DATA"
                        total_va_ch1 = total_va_ch1 + buf(4)
                        total_va_ch2 = total_va_ch2 + buf(7)
                        If HW_STAT.ZeroCross_curcuit Then
                            data_display("", buf(1), buf(2), buf(3) * 10, buf(6) * 10, buf(4) * 10, buf(7) * 10, 0)
                            total_watt_ch1 = total_watt_ch1 + buf(3)
                            total_watt_ch2 = total_watt_ch2 + buf(6)
                        Else
                            data_display("", buf(1), buf(2), 0, 0, buf(4) * 10, buf(7) * 10, 0)
                        End If
                        record_no_graph = record_no_graph + 1
                End Select
                If (record_no_graph Mod 10000) = 0 Then
                    Application.DoEvents()
                End If
            End While
            If HW_STAT.ZeroCross_curcuit Then
                Label_avg1.Text = "平均電力：" & (total_watt_ch1 / record_no_graph).ToString("0.0") & _
                                  "　平均VA：" & (total_va_ch1 / record_no_graph).ToString("0.0")
                Label_avg2.Text = "平均電力：" & (total_watt_ch2 / record_no_graph).ToString("0.0") & _
                                  "　平均VA：" & (total_va_ch2 / record_no_graph).ToString("0.0")
            Else
                Label_avg1.Text = "　平均VA：" & (total_va_ch1 / record_no_graph).ToString("0.0")
                Label_avg2.Text = "　平均VA：" & (total_va_ch2 / record_no_graph).ToString("0.0")
            End If

            'rec = False
        End If
    End Sub

    Private Sub exitpgm_Click(sender As System.Object, e As System.EventArgs) Handles exitpgm.Click
        Application.Exit()
    End Sub

    Private Sub Chart1_CursorPositionChanged(sender As System.Object, e As System.Windows.Forms.DataVisualization.Charting.CursorEventArgs) Handles Chart1.CursorPositionChanged
        Dim x As Integer
        Dim watt1, watt2 As Double
        Dim va1, va2 As Double
        Dim pf1, pf2 As Double

        If 0 < Chart1.ChartAreas.FindByName("ChartArea1").CursorX.Position Then
            x = Chart1.ChartAreas.FindByName("ChartArea1").CursorX.Position
            If x <= Chart1.Series(0).Points.Count Then
                If HW_STAT.ZeroCross_curcuit Then
                    watt1 = Chart1.Series(0).Points.Item(x).YValues(0)
                    watt2 = Chart1.Series(3).Points.Item(x).YValues(0)
                    pf1 = Chart1.Series(2).Points.Item(x).YValues(0)
                    pf2 = Chart1.Series(5).Points.Item(x).YValues(0)
                End If
                va1 = Chart1.Series(1).Points.Item(x).YValues(0)
                va2 = Chart1.Series(4).Points.Item(x).YValues(0)
                display_text(watt1, watt2, va1, va2, pf1, pf2)
                Label_seq_no.Text = "記録番号：" & x
            End If
        End If
    End Sub

End Class
